//
//  Connection.h
//  SocketServer
//
//  Created by Clemens Wagner on 05.09.15.
//  Copyright © 2015 Clemens Wagner. All rights reserved.
//

#import <Foundation/Foundation.h>

@protocol ConnectionDelegate;

@interface Connection : NSObject

@property (weak, nonatomic) id<ConnectionDelegate> delegate;
@property (copy, nonatomic, readonly) NSString *registeredName;
@property (strong, nonatomic, readonly) NSInputStream *inputStream;
@property (strong, nonatomic, readonly) NSOutputStream *outputStream;

- (instancetype)initWithName:(NSString *)inName
                 inputStream:(NSInputStream *)inInputStream
                outputStream:(NSOutputStream *)inOutputStream;

@end

@protocol ConnectionDelegate<NSObject>

@optional
- (NSCachedURLResponse *)connection:(Connection *)inConnection responseForRequest:(NSURLRequest *)inRequest;
- (void)connection:(Connection *)inConnection didWriteResponse:(NSCachedURLResponse *)inResponse;

@end